Loading...
Searching...
No Matches
concepts.h File Reference

Concept-checking macros for geometric objects Each macro instantiates a concept check structure, which includes a static function that will fail to compile if the concept does not pass. More...

Go to the source code of this file.

## Classes

class | gtsam::PoseConcept< POSE >
| Pose Concept A must contain a translation and a rotation, with each structure accessable directly and a type provided for each. More...

## Namespaces

namespace | gtsam
| Global functions in a separate testing namespace.

## Macros

#define | GTSAM_CONCEPT_POSE_INST(T)
| Macros to use geometry concepts:
#define | GTSAM_CONCEPT_POSE_TYPE(T)

## Detailed Description

Concept-checking macros for geometric objects Each macro instantiates a concept check structure, which includes a static function that will fail to compile if the concept does not pass.

Functions are made static to ensure they get instantiated.

Date
  Oct 6, 2011

Author
  Alex Cunningham

## Macro Definition Documentation

## GTSAM_CONCEPT_POSE_INST

#define GTSAM_CONCEPT_POSE_INST | ( |  | T | ) |

Value:
template class gtsam::PoseConcept<T>;
gtsam::PoseConcept
Pose Concept A must contain a translation and a rotation, with each structure accessable directly and...
Definition concepts.h:39

Macros to use geometry concepts:

- _INST macro: instantiates a struct: use in unit tests, but not in headers.
- _TYPE macro: use in generic structures to validate the template arguments.

NOTE: intentionally not in the gtsam namespace to avoid namespace complications when using with objects not inside gtsam namespace. Pose Concept macros

## GTSAM_CONCEPT_POSE_TYPE

#define GTSAM_CONCEPT_POSE_TYPE | ( |  | T | ) |

Value:
using _gtsam_PoseConcept##T = gtsam::PoseConcept<T>;